<?php 
/**
 * Tablas con casillas de verificación (Resultado 1) - for_3_4b.php
 * 
 * @author    Bartolomé Sintes Marco <bartolome.sintes+mclibre@gmail.com>
 * @copyright 2010 Bartolomé Sintes Marco
 * @license   http://www.gnu.org/licenses/agpl.txt AGPL 3 or later
 * @version   2011-11-14
 * @link      http://www.mclibre.org
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

print "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?".">\n"; 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <title>Tablas con casillas de verificación (Resultado 2). for (3). 
  Ejercicios. PHP. Bartolomé Sintes Marco</title>
  <link href="mclibre_php_soluciones.css" rel="stylesheet" type="text/css" 
  title="Color" />
</head>
<body>

<h1>Tablas con casillas de verificación (Resultado 2)</h1>
<?php
function recoge($var)
{ 
    $tmp = (isset($_REQUEST[$var])) ? trim(strip_tags($_REQUEST[$var])) : '';
    if (get_magic_quotes_gpc()) {
        $tmp = stripslashes($tmp);
    }
    $tmp = str_replace('&', '&amp;',  $tmp);
    $tmp = str_replace('"', '&quot;', $tmp);
    return $tmp;
}

function recogeMatriz2($var) 
{
    $tmpMatriz = array();
    if (isset($_REQUEST[$var]) && is_array($_REQUEST[$var])) {
        foreach ($_REQUEST[$var] as $indice => $fila) {
            $tmp = trim(strip_tags($indice));
            if (get_magic_quotes_gpc()) {
                $tmp = stripslashes($tmp);
            }
            $tmp = str_replace('&', '&amp;',  $tmp);
            $tmp = str_replace('"', '&quot;', $tmp);
            $indiceLimpio = $tmp;
            if (is_array($fila)) {
                foreach ($fila as $indice2 => $valor) {
                    $tmp = trim(strip_tags($indice2));
                    if (get_magic_quotes_gpc()) {
                        $tmp = stripslashes($tmp);
                    }
                    $tmp = str_replace('&', '&amp;',  $tmp);
                    $tmp = str_replace('"', '&quot;', $tmp);
                    $indice2Limpio = $tmp;
        
                    $tmp = trim(strip_tags($valor));
                    if (get_magic_quotes_gpc()) {
                        $tmp = stripslashes($tmp);
                    }
                    $tmp = str_replace('&', '&amp;',  $tmp);
                    $tmp = str_replace('"', '&quot;', $tmp);
                    $valorLimpio  = $tmp;
        
                    $tmpMatriz[$indiceLimpio][$indice2Limpio] = $valorLimpio;
                }                      
            }
        }
    }
    return $tmpMatriz;
}

$tablas       = recoge('tablas');
$tamanyo      = recoge('tamanyo');
$casillas     = recogeMatriz2('c');
$tablasMinimo = $tamanyoMinimo = 1;
$tablasMaximo = $tamanyoMaximo = 20;
$casillaValor = 'on';
$tablasOk  = $tamanyoOk = $casillasOk = FALSE;
$casillasMarcadas = count($casillas, COUNT_RECURSIVE)-count($casillas);

if ($tablas=="") {
    print "<p class=\"aviso\">No ha escrito el número de tablas.</p>\n";
} elseif (!ctype_digit($tablas)) { 
    print "<p class=\"aviso\">No ha escrito el número de tablas  "
        ."como número entero positivo.</p>\n";
} elseif (($tablas<$tablasMinimo) || ($tablas>$tablasMaximo)) {
    print "<p class=\"aviso\">El número de tablas debe estar entre "
        ."$tablasMinimo y $tablasMaximo.</p>\n";
} else {
    $tablasOk = TRUE;
}

if ($tamanyo=="") {
    print "<p class=\"aviso\">No ha escrito el tamaño de la tabla.</p>\n";
} elseif (!ctype_digit($tamanyo)) { 
    print "<p class=\"aviso\">No ha escrito el tamaño de la tabla "
        ."como número entero.</p>\n";
} elseif (($tamanyo<$tamanyoMinimo) || ($tamanyo>$tamanyoMaximo)) {
    print "<p class=\"aviso\">El tamaño de la tabla debe estar entre "
        ."$tamanyoMinimo y $tamanyoMaximo.</p>\n";
} else {
    $tamanyoOk = TRUE;
}

if ($casillasMarcadas==0) {
    print "<p>No ha marcado ninguna casilla.</p>";
} elseif ($casillasMarcadas>$tamanyo*$tamanyo*$tablas) {
        print "<p style=\"color:red\">La matriz recibida es demasiado grande.</p>\n";
} else {
    $casillasOk = TRUE;
    foreach ($casillas as $indice => $valor) {
        if (ctype_digit((string)$indice)&&($indice<=$tablas)&&is_array($valor)) {
            foreach ($valor as $indice2 => $valor2) {
                if (!ctype_digit((string)$indice2)||($indice2>$tamanyo*$tamanyo)||($valor2!=$casillaValor)) {
                    $casillasOk = FALSE;
                }
            }
        } else {
            $casillasOk = FALSE;
        }    	
    }
    if (!$casillasOk) {
        print "<p style=\"color:red\">La matriz recibida no es correcta.</p>\n";
    }    
}

if ($tablasOk && $tamanyoOk && $casillasOk) {
    for ($k=1; $k<=$tablas; $k++) {
        if (!isset($casillas[$k])) {
            print "<p>En la tabla <strong>$k</strong> no ha marcado ninguna casilla.</p>\n";
        } else {
            print "<p>En la tabla <strong>$k</strong> ha marcado <strong>".
                count($casillas[$k])."</strong> casilla";
            if (count($casillas[$k])>1) {
                print "s";
            }
            print " de un total de ".
                ($tamanyo*$tamanyo).": ";
            foreach ($casillas[$k] as $indice => $valor) {
                print "<strong>$indice</strong> ";
            }
            print "</p>\n";
        }
    }
    print "<p><a href=\"for_3_4a.php?tamanyo=$tamanyo&amp;tablas=$tablas\">Volver a las tablas</a></p>\n";
}

print "<p><a href=\"for_3_4.html\">Volver al formulario inicial.</a></p>\n";
?>

<address>
  Esta página forma parte del curso "Páginas web con PHP" disponible en <a
  href="http://www.mclibre.org/">http://www.mclibre.org</a><br />
  Autor: Bartolomé Sintes Marco<br />
  Última modificación de esta página: 14 de noviembre de 2011
</address>
<p class="licencia">El programa PHP que genera esta página está bajo 
<a rel="license" href="http://www.gnu.org/licenses/agpl.txt">licencia AGPL 3 o
posterior</a>.</p>
</body>
</html>
